#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "keyb.h"
#include "lcd.h"

int readNumber() {
	char input[6];
	uint8_t inputIndex = 0;
	while(inputIndex < (sizeof(input) - 1)) {
		uint8_t key = 0;
		key = getKey();
		if (key == 15) {
			if (inputIndex > 0) {
				inputIndex--;
				lcdWriteCommand(LCD_COMMAND_SHIFT);
				printf("%c", ' ');
				lcdWriteCommand(LCD_COMMAND_SHIFT);
			}
			continue;
		}
		if (key < 10) input[inputIndex] = '0' + key;
		if (key == 10) input[inputIndex] = '0';
		if (key == 16) {
			break;
		}
		printf("%c", input[inputIndex]);
		inputIndex++;
	}
	input[inputIndex] = 0;
	return atoi(input);
}

void readTime(uint8_t * hours, uint8_t * minutes, uint8_t * seconds) {
	uint8_t input[6];
	uint8_t inputIndex = 0;
	uint8_t key = 0;
	while(1) {
		key = getKey();
		if (key == 15) {
			if (inputIndex > 0) {
				if (inputIndex == sizeof(input) - 1) {
					 printf("%c", ' ');
					 lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_LEFT);
				}
				inputIndex--;
				if (inputIndex == 1 || inputIndex == 3) lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_LEFT);
				lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_LEFT);
				printf("%c", ' ');
				lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_LEFT);
			}
			continue;
		}
		if (key < 10) input[inputIndex] = key;
		if (key == 10) input[inputIndex] = 0;
		if (key == 16) {
			break;
		}
		printf("%c", '0' + input[inputIndex]);
		if (inputIndex == 1 || inputIndex == 3) lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_RIGHT);
		if (inputIndex < sizeof(input) - 1) {
			inputIndex++;
		} else {
			lcdWriteCommand(LCD_COMMAND_SHIFT | LCD_PARAM_SHIFT_LEFT);
		}
	}
	*hours = 10 * input[0] + input[1];
	*minutes = 10 * input[2] + input[3];
	*seconds = 10 * input[4] + input[5];
}

uint8_t readKeyboard() {
	for (uint8_t row = 0; row < 4; row++){
		KEYB_PORT = ~_BV(row);
		_delay_us(1);
		for (uint8_t column = 0; column < 4; column++){
			if (~KEYB_PIN & _BV(column + 4)) {
				return row * 4 + column + 1;
			}
		}
	}
	return 0;
}

uint8_t getKey() {
	uint8_t key = 0;
	while (!(key = readKeyboard()));
	while (readKeyboard());
	_delay_ms(30);
	return key;
}

void keybInit() {
	KEYB_DDR = 0x0f;
}